library plugin;

uses
  Windows,
  PlugInHeader in 'PlugInHeader.pas'; //Global declarations

{$R *.RES}

////////////////////////////////////////////
//
// Required Plugin vars
//
////////////////////////////////////////////

const
 PluginName = 'Test Plugin'; //This is the name for your Plugin

var
 AppEventProc : TEventProc;  //Call to cause an event within the Application
 SessionID    : Integer;

////////////////////////////////////////////
//
// Use SendEventToApp to easily send events
//  to your application
//
////////////////////////////////////////////

function SendEventToApp(const EventCode : LongWord; Params : Pointer) : Pointer;
begin
     Result:=AppEventProc(EventCode,SessionID,Params);
end;


////////////////////////////////////////////
//
// User methods
//
//  Place all your methods here
//
////////////////////////////////////////////




////////////////////////////////////////////
//
// Required Plugin EventHandler
//
//  (MUST be named according to PluginProcName
//   in PluginHeader)
//
////////////////////////////////////////////

// Handles all events from the Application
function EventHandler(const EventCode : LongWord; const PluginID : Integer; Params : Pointer) : Pointer; stdcall;
begin
     Result:=nil;
     CASE EventCode of
       { REQUIRED Initialization code }
       evpInit    :  begin //Initialization
                      AppEventProc:=TEventProc(Params); //Get Controller's EventHandler proc address
                      SessionID:=PluginID; //Get SessionID, used to identify events from THIS Plugin

                      //Pass it back this Plugin's name
                      Result:=PChar(PluginName);
                     end;

       { User-defined events }

      end;
end;

exports
 EventHandler;

begin
     AppEventProc:=nil; //test to make sure it is initialized
end.
