unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, GDPlugin;

type
  TForm1 = class(TForm)
    edtCode: TSpinEdit;
    btnSendToAll: TButton;
    GDController: TGDPlugInController;
    lstPlugins: TListBox;
    btnLoad: TButton;
    btnUnload: TButton;
    Label1: TLabel;
    btnSendToOne: TButton;
    OpenDialog: TOpenDialog;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    btnAdd23: TButton;
    Label2: TLabel;
    btnStatus: TButton;
    btnError: TButton;
    btnIDError: TButton;
    procedure GDControllerLoaded(const PlugInIndex: Integer);
    procedure btnLoadClick(Sender: TObject);
    procedure btnUnloadClick(Sender: TObject);
    procedure btnSendToAllClick(Sender: TObject);
    procedure btnSendToOneClick(Sender: TObject);
    procedure btnAdd23Click(Sender: TObject);
    function GDControllerPlugInEvent(const PlugInIndex: Integer;
      const EventCode: Cardinal; Params: Pointer): Pointer;
    procedure btnStatusClick(Sender: TObject);
    procedure btnIDErrorClick(Sender: TObject);
    procedure btnErrorClick(Sender: TObject);
    procedure GDControllerPluginError(const ErrorCode: GDPluginError;
      const PluginIndex: Integer);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses PluginHeader;

procedure TForm1.GDControllerLoaded(const PlugInIndex: Integer);
begin
     IF not(lstPlugIns=nil) then GDController.PopulateStrings(lstPlugIns.Items);
end;

procedure TForm1.btnLoadClick(Sender: TObject);
begin
     IF (OpenDialog.Execute) then
       begin
        IF (GDController.LoadPlugIn(OpenDialog.FileName))
          then IF (lstPlugins.SelCount=0) and (lstPlugins.Items.Count>0) then lstPlugins.Selected[0]:=TRUE
          else MessageDLG('Error loading plugin.',mtError,[mbOk],0);
       end;
end;

procedure TForm1.btnUnloadClick(Sender: TObject);
var
 g : Integer;
begin
     IF (lstPlugins.SelCount>0) then
       begin
        //Unload selected
        g:=0;
        While (g<lstPlugins.Items.Count) do
          IF (lstPlugins.Selected[g]) then
            begin
             GDController.UnloadPlugIn(g);
             lstPlugins.Items.Delete(g);
            end
           else Inc(g);
       end;
end;

procedure TForm1.btnSendToAllClick(Sender: TObject);
begin
     IF (lstPlugins.Items.Count>0) then GDController.SendEventToAll(edtCode.Value,0,nil);
end;

procedure TForm1.btnSendToOneClick(Sender: TObject);
var
 g : Integer;
begin
     IF (lstPlugins.SelCount>0) then
       begin
        FOR g:=0 to lstPlugins.Items.Count-1 do
          IF (lstPlugins.Selected[g]) then GDController.SendEventToOne(g,edtCode.Value,0,nil);
       end;
end;

procedure TForm1.btnAdd23Click(Sender: TObject);
var
 g,Res : Integer;
begin
     IF (lstPlugins.SelCount>0) then
       begin
        FOR g:=0 to lstPlugins.Items.Count-1 do
          IF (lstPlugins.Selected[g]) then
            begin
             Res:=Integer( GDController.SendEventToOne(0,evpAdd,2,Pointer(3)) );
             ShowMessage( IntToStr(Res) );
            end;
       end;
end;

function TForm1.GDControllerPlugInEvent(const PlugInIndex: Integer; const EventCode: Cardinal; Params: Pointer): Pointer;
begin
     Result:=nil;
     CASE EventCode of
       evaStatus   :  begin
                       ShowMessage( GDController.PluginName[PluginIndex]+' status: '+String(PChar(Params)) );
                      end;
       else ShowMessage( GDController.PluginName[PluginIndex]+' sent an erroneous EventCode ('+IntToStr(EventCode)+')' );
      end;
end;

procedure TForm1.btnStatusClick(Sender: TObject);
var
 g : Integer;
begin
     IF (lstPlugins.SelCount>0) then
       begin
        FOR g:=0 to lstPlugins.Items.Count-1 do
          IF (lstPlugins.Selected[g]) then GDController.SendEventToOne(g,evpStatus,0,nil);
       end;
end;

procedure TForm1.btnIDErrorClick(Sender: TObject);
var
 g : Integer;
begin
     IF (lstPlugins.SelCount>0) then
       begin
        FOR g:=0 to lstPlugins.Items.Count-1 do
          IF (lstPlugins.Selected[g]) then GDController.SendEventToOne(g,evpIDError,0,nil);
       end;
end;

procedure TForm1.btnErrorClick(Sender: TObject);
var
 g : Integer;
begin
     IF (lstPlugins.SelCount>0) then
       begin
        FOR g:=0 to lstPlugins.Items.Count-1 do
          IF (lstPlugins.Selected[g]) then GDController.SendEventToOne(g,evpError,0,nil);
       end;
end;

procedure TForm1.GDControllerPluginError(const ErrorCode: GDPluginError; const PluginIndex: Integer);
begin
     ShowMessage('Received erroneous PluginID.');
end;

end.
